"use strict";
exports.__esModule = true;
var gutil = require("gulp-util");
var through = require("through2");
var _ = require("lodash");
var template = _.template;
function compile(data, options, render) {
    if (options === void 0) { options = {}; }
    if (render === void 0) { render = true; }
    return through.obj(function (file, enc, cb) {
        if (file.isNull()) {
            cb(null, file);
            return;
        }
        if (file.isStream()) {
            cb(new gutil.PluginError('gulp-template', 'Streaming not supported'));
            return;
        }
        try {
            var tpl = template(file.contents.toString(), options);
            file.contents = new Buffer(render ? tpl(_.merge({}, file.data, data)) : tpl.toString());
            this.push(file);
        }
        catch (err) {
            this.emit('error', new gutil.PluginError('gulp-template', err, { fileName: file.path }));
        }
        cb();
    });
}
exports.compile = compile;
