import * as gutil from 'gulp-util';
import * as through from 'through2';
import * as _ from 'lodash';

const template: any = _.template;

export function compile(data: any, options: object = {}, render: any = true) {
  return through.obj(function (file: any, enc: any, cb: any) {
    if (file.isNull()) {
      cb(null, file);
      return;
    }

    if (file.isStream()) {
      cb(new gutil.PluginError('gulp-template', 'Streaming not supported'));
      return;
    }

    try {
      const tpl = template(file.contents.toString(), options);
      file.contents = new Buffer(render ? tpl(_.merge({}, file.data, data)) : tpl.toString());
      this.push(file);
    } catch (err) {
      this.emit('error', new gutil.PluginError('gulp-template', err, { fileName: file.path }));
    }

    cb();
  });
}
